<div class="users-table">
  <nz-table #usersTable
            [nzData]="this.users"
            nzSize="small"
            nzTableLayout="auto"
            [nzBordered]="true"
            nzTableLayout="fixed"
            [nzFrontPagination]="false"
            [nzTotal]="this.pagination?.totalResults"
            [nzPageSize]="this.pagination?.resultsPerPage"
            [nzPageIndex]="this.pagination?.page"
            [nzShowSizeChanger]="true"
            (nzPageSizeChange)="onPageSizeChange($event)"
            (nzPageIndexChange)="onPageNumberChange($event)"
            (nzQueryParams)="onQueryParamsChange($event)">
    <thead>
      <tr>
        <th class="avatar-column"
            nzColumnKey="avatar">Avatar</th>
        <th nzColumnKey="name"
            [nzSortFn]="true">Name</th>
        <th nzColumnKey="username"
            [nzSortFn]="true">Username</th>
        <th nzColumnKey="email">Email</th>
        <th class="role-column"
            nzColumnKey="role">Role</th>
        <th class="edit-column"
            nzColumnKey="edit">Edit</th>
        <th class="delete-column"
            nzColumnKey="delete">Delete</th>
      </tr>
    </thead>
    <tbody>
      <tr *ngFor="let user of usersTable.data">
        <ng-container *ngIf="!this.showEditMode || this.selectedUser !== user">
          <td>
            <div class="user-avatar">
              <nz-avatar class="user-icon"
                         nzShape="square"
                         *ngIf="user.avatarUrl"
                         [nzSize]="42"
                         [nzSrc]="avatarsUrl + user.avatarUrl">
              </nz-avatar>
              <nz-avatar class="user-icon"
                         nzShape="square"
                         nzIcon="user"
                         [nzSize]="42"
                         *ngIf="!user.avatarUrl">
              </nz-avatar>
            </div>
          </td>
          <td>{{ user.name }}</td>
          <td>{{ user.username }}</td>
          <td>{{ user.email }}</td>
          <td>{{ user.role }}</td>
          <td><a (click)="onEditButtonClicked(user)">Edit</a></td>
          <td><a *ngIf="this.loggedUserData?.id !== user?.id"
               nz-popconfirm
               nzTitle="Are you sure you want to delete this user?"
               (nzOnConfirm)="deleteUser(user)"
               nzOkText="Yes"
               nzCancelText="No">Delete</a></td>
        </ng-container>

        <ng-container *ngIf="this.showEditMode && this.selectedUser === user">
          <td>
            <div class="user-avatar">
              <nz-avatar nzShape="square"
                         *ngIf="user.avatarUrl"
                         [nzSize]="42"
                         [nzSrc]="avatarsUrl + user.avatarUrl">
              </nz-avatar>
              <nz-avatar class="user-icon"
                         nzShape="square"
                         nzIcon="user"
                         [nzSize]="42"
                         *ngIf="!user.avatarUrl">
              </nz-avatar>
            </div>
          </td>
          <td><input type="text"
                   nz-input
                   [(ngModel)]="this.nameInput" /></td>
          <td><input type="text"
                   nz-input
                   [(ngModel)]="this.usernameInput" /></td>
          <td><input type="text"
                   nz-input
                   [(ngModel)]="this.emailInput" /></td>
          <td>
            <nz-select [(ngModel)]="this.roleInput">
              <nz-option *ngFor="let role of roles"
                         [nzValue]="role"
                         [nzLabel]="role"></nz-option>
            </nz-select>
          </td>
          <td>
            <a nz-popconfirm
               nzTitle="Are you sure you want to save the changes?"
               (nzOnConfirm)="updateUser()"
               nzOkText="Yes"
               nzCancelText="No">Save</a>
            <a (click)="showEditMode = false"
               class="cancel">Cancel</a>
          </td>
        </ng-container>
      </tr>
    </tbody>
  </nz-table>
</div>
